<script>
	import { goto } from '$app/navigation'

	import { onMount, tick } from 'svelte'

	onMount(async () => await import('@google/model-viewer'))
	let didUplaod = false
	let showUpper = true
	let showLower = true
	let showSick = false

	let viewer
	let scene

	let models = {
		isLoaded: false
	}
	function OnModelReady() {
		scene = Object.getOwnPropertySymbols(viewer).find((x) => x.description === 'scene')
		models = {
			upper: viewer[scene].modelContainer.children[0].children[0].children[0],
			lower: viewer[scene].modelContainer.children[0].children[0].children[1]
		}

		models.isLoaded = true
		updateVisibility()
	}

	function updateVisibility() {
		if (!models.isLoaded) return

		models.lower.visible = showLower
		models.upper.visible = showUpper
		viewer[scene].isDirty = true
	}

	function updateHighlight() {
		if (!models.isLoaded) return
		viewer[scene].isDirty = true
	}

	let showPopup = false
	async function onDataUploaded() {
		showPopup = false
		showSick = true
		didUplaod = true
		await tick()
		updateHighlight()
	}

	function onClick(e) {
		if (e.target.dataset.toothId) {
			if (showSick) {
				goto(`/tooth?id=${e.target.dataset.toothId}&sick=${e.target.dataset.isSick}`)
			} else {
				goto(`/tooth?id=${e.target.dataset.toothId}`)
			}
		}
	}
</script>

{#if showPopup}
	<div
		class="flex h-screen w-screen  p-4 inset-0 z-1000 fixed justify-center items-center"
	>
		<div
			class="bg-white rounded flex flex-col shadow-md max-w-96 py-6  px-3 z-1000 relative items-center justify-center"
		>
			<svg
				class="h-20 text-gray-300 w-20"
				fill="none"
				viewBox="0 0 24 24"
				stroke="currentColor"
			>
				<path
					stroke-linecap="round"
					stroke-linejoin="round"
					stroke-width="2"
					d="M7 16a4 4 0 01-.88-7.903A5 5 0 1115.9 6L16 6a5 5 0 011 9.9M15 13l-3-3m0 0l-3 3m3-3v12"
				/>
			</svg>
			<p class="mt-4 text-center text-gray-400">
				Reach out to your dentist and get a your data then upload it here for more details
			</p>
			<button
				on:click={onDataUploaded}
				class="rounded flex font-bold bg-indigo-600 shadow-md mt-6 text-white py-2 px-6 block items-center"
			>
				<span>Upload File</span>
			</button>
		</div>

		<div class="bg-black bg-opacity-80 inset-0 absolute" />
	</div>
{/if}

<model-viewer
	bind:this={viewer}
	on:load={OnModelReady}
	loading="eager"
	camera-controls
	class:showSick
	src="/assets/models/teeth.glb"
	on:click={onClick}
>
	<fieldset class="controls">	
		<label>
			<input type="checkbox" bind:checked={showUpper} on:change={updateVisibility} />
			<span>Upper</span>
		</label>
		<label>
			<input type="checkbox" bind:checked={showLower} on:change={updateVisibility} />
			<span>Lower</span>
		</label>
		{#if didUplaod}
			<label>
				<input type="checkbox" bind:checked={showSick} on:change={updateHighlight} />
				<span>Sick</span>
			</label>
		{:else}
			<button
				on:click={() => (showPopup = true)}
				class="rounded flex ml-auto bg-yellow-400 shadow-md py-1 px-2 text-yellow-900 items-center"
			>
				<svg class="h-5 mr-2 w-5" viewBox="0 0 20 20" fill="currentColor">
					<path
						fill-rule="evenodd"
						clip-rule="evenodd"
						d="M8.257 3.099c.765-1.36 2.722-1.36 3.486 0l5.58 9.92c.75 1.334-.213 2.98-1.742 2.98H4.42c-1.53 0-2.493-1.646-1.743-2.98l5.58-9.92zM11 13a1 1 0 11-2 0 1 1 0 012 0zm-1-8a1 1 0 00-1 1v3a1 1 0 002 0V6a1 1 0 00-1-1z"
					/>
				</svg>
				<span>Show More Details</span>
			</button>
		{/if}
	</fieldset>

	<button
		class="Hotspot"
		slot="hotspot-1"
		data-position="-32.31129852803821m 26.95176490586367m -16.605043153680285m"
		data-normal="-0.9009854774847977m -0.04240878859117015m 0.4317715414564981m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="01" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-2"
		data-position="-31.010590499947085m 27.57107656720595m -7.913868638864038m"
		data-normal="-0.9726381145543039m -0.14632658085273134m 0.1804539549364266m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="02" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-3"
		data-position="-27.65030394224786m 27.14102175153106m 0.7064994379515355m"
		data-normal="-0.8834411783142684m -0.11077006286128743m 0.45526001101832275m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="03" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-4"
		data-position="-24.192886130190885m 26.817327925621022m 10.202366567408323m"
		data-normal="-0.8171697116996232m -0.11403250216652971m 0.5650046466449594m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="04" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-5"
		data-position="-20.248173060665316m 27.225784540013702m 17.7703028615109m"
		data-normal="-0.6992142850879364m -0.06922455034531186m 0.7115527704664324m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="05" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-6"
		data-position="-14.806015071053803m 28.176179599253352m 22.73398282706448m"
		data-normal="-0.6814374209382822m 0.1473082132280142m 0.7168984109764455m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="06" data-is-sick="true" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-7"
		data-position="-7.272858404660404m 27.926920276635684m 25.715733522015128m"
		data-normal="-0.23275897867401357m 0.0021334291490900915m 0.9725321106918249m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="07" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-8"
		data-position="1.4705022495994768m 26.8817911076614m 26.033325231896086m"
		data-normal="0.03995229010628614m -0.12227434384024516m 0.9916918873086039m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="08" data-is-sick="true" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-9"
		data-position="11.07921037018549m 27.422565920668927m 23.433899002031964m"
		data-normal="0.5737993751545616m -0.028497543270365317m 0.8184999493584519m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="09" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-10"
		data-position="18.07017882209618m 27.789057009834778m 17.68123790835834m"
		data-normal="0.7674960078257382m -0.3521039655850617m 0.5356983063169307m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="10" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-11"
		data-position="22.296598317763554m 26.566651646437666m 10.565126198618827m"
		data-normal="0.7775943940319779m -0.2919918855259857m 0.556855185085872m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="11" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-12"
		data-position="25.771004536933475m 25.69989558176972m 1.3049699871854017m"
		data-normal="0.9043373653618376m -0.3903447205461798m 0.1726410401733472m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="12" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-13"
		data-position="29.576572544097687m 26.161208052474475m -6.148916371391081m"
		data-normal="0.9279079738103362m -0.18381157213175364m 0.32434564601617516m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="13" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-14"
		data-position="32.009751139989746m 25.443905413007997m -14.769730035269205m"
		data-normal="0.9001565535169537m -0.21437585319986363m 0.3791585060701002m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="14" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-15"
		data-position="-28.85667572064635m 17.331784302834908m -16.216702232303916m"
		data-normal="-0.5667730404705341m 0.8232030482400184m 0.03324247229266132m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="15" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-16"
		data-position="-26.271817262984513m 15.87568226823657m -5.0014086791914m"
		data-normal="-0.8401503392034431m 0.531586254636604m 0.10753353624691893m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="16" data-is-sick="true" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-17"
		data-position="-21.542144773902763m 15.323422763717506m 6.870710313966612m"
		data-normal="-0.8173396814870122m 0.4805008735673183m 0.31792256221877907m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="17" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-18"
		data-position="-17.5902404531544m 15.135788174813126m 15.38207693325569m"
		data-normal="-0.6837584564270877m 0.3542187434069744m 0.6379682241958691m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="18" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-19"
		data-position="-11.124757307132827m 16.77149362921748m 21.359689126308922m"
		data-normal="-0.4727862284467142m 0.4371355859303907m 0.7651050004440081m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="19" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-20"
		data-position="-6.3148620216408755m 18.141042781032862m 25.24241917781511m"
		data-normal="-0.19737724444661287m 0.14820458502390335m 0.9690601758160092m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="20" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-21"
		data-position="-1.4139409437262263m 18.205047410209577m 26.05773022419403m"
		data-normal="-0.07099549717075034m 0.13457694381801283m 0.9883565579152503m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="21" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-22"
		data-position="4.518315866909781m 18.227653618939772m 25.60762256675048m"
		data-normal="-0.08074937642299354m 0.15288099715978087m 0.9849400686918615m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="22" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-23"
		data-position="9.614476524433215m 17.751754496600455m 24.042672976299997m"
		data-normal="0.171465692002628m 0.22452520838748993m 0.9592642739436377m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="23" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-24"
		data-position="15.704335635769468m 16.79057458033283m 19.934164265490978m"
		data-normal="0.6700806419109202m 0.39469255277689047m 0.6286570783175123m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="24" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-25"
		data-position="19.789553078951705m 15.171064076456844m 14.908847774840808m"
		data-normal="0.45507366873870325m 0.488462467638837m 0.7445215737162189m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="25" data-is-sick="true" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-26"
		data-position="23.558379608488877m 14.51352565726002m 5.94936245424762m"
		data-normal="0.7047865941273374m 0.676273637058531m 0.21431244611084574m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="26" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-27"
		data-position="27.57524672723531m 14.66225420667979m -5.345292993004165m"
		data-normal="0.6632018255319251m 0.7386346492263575m 0.12075675373815727m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="27" data-is-sick="fasle" />
	</button>
	<button
		class="Hotspot"
		slot="hotspot-28"
		data-position="29.473331682830207m 15.304101179118039m -14.429054591369614m"
		data-normal="0.6952679444871307m 0.5588525602208996m 0.4519804213715303m"
		data-visibility-attribute="visible"
	>
		<div class="HotspotAnnotation" data-tooth-id="28" data-is-sick="fasle" />
	</button>
</model-viewer>

<style>
	model-viewer {
		--poster-color: transparent;
		width: 100%;
		height: 100%;
	}

	model-viewer .controls {
		@apply flex m-4;

		& label {
			@apply select-none;
		}

		& input {
			@apply absolute w-0 h-0 opacity-0;
		}

		& input ~ span {
			@apply block py-1 px-2 bg-gray-400 text-gray-50 cursor-pointer;
		}

		& label:first-child span {
			@apply rounded-l;
		}
		& label:last-of-type span {
			@apply rounded-r;
		}

		& input:checked ~ span {
			@apply bg-indigo-500 text-indigo-50;
		}
	}

	model-viewer button {
		@apply outline-none;
	}

	.HotspotAnnotation {
		@apply h-5 w-5 rounded-full;
	}

	.showSick .HotspotAnnotation[data-is-sick='true'] {
		@apply bg-red-600 h-3 w-3;
	}
</style>
